package freechartservlet;

import java.awt.image.RenderedImage;
import java.io.IOException;
import java.text.NumberFormat;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.labels.StandardPieSectionLabelGenerator;
import org.jfree.chart.plot.PiePlot;
import org.jfree.data.general.DefaultPieDataset;

public class grafico extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("image/png");
        try (ServletOutputStream os = response.getOutputStream()) {

            int lista1 = Integer.parseInt(request.getParameter("lista1"));
            int lista2 = Integer.parseInt(request.getParameter("lista2"));
            int lista3 = Integer.parseInt(request.getParameter("lista3"));
            int lista4 = Integer.parseInt(request.getParameter("lista4"));
            int lista5 = Integer.parseInt(request.getParameter("lista5"));
            int tot = lista1 + lista2 + lista3 + lista4 + lista5;

            DefaultPieDataset dataset = new DefaultPieDataset();
            dataset.setValue("Lista 1", lista1);
            dataset.setValue("Lista 2", lista2);
            dataset.setValue("Lista 3", lista3);
            dataset.setValue("Lista 4", lista4);
            dataset.setValue("Lista 5", lista5);

            JFreeChart chart = ChartFactory.createPieChart("Elezioni scolastiche",
                    dataset, true, true, false);
            ((PiePlot) chart.getPlot()).setLabelGenerator(new StandardPieSectionLabelGenerator("{0} = {2}", NumberFormat.getNumberInstance(), NumberFormat.getPercentInstance()));

            RenderedImage chartImage = chart.createBufferedImage(700, 500);
            ImageIO.write(chartImage, "png", os);
            os.flush();
            os.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
